// Auto-generated. Do not edit!

// (in-package marti_nav_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let PlanPoint = require('./PlanPoint.js');
let PlanPointProperty = require('./PlanPointProperty.js');
let marti_common_msgs = _finder('marti_common_msgs');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class Plan {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.points = null;
      this.point_properties = null;
      this.id = null;
      this.properties = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('points')) {
        this.points = initObj.points
      }
      else {
        this.points = [];
      }
      if (initObj.hasOwnProperty('point_properties')) {
        this.point_properties = initObj.point_properties
      }
      else {
        this.point_properties = [];
      }
      if (initObj.hasOwnProperty('id')) {
        this.id = initObj.id
      }
      else {
        this.id = '';
      }
      if (initObj.hasOwnProperty('properties')) {
        this.properties = initObj.properties
      }
      else {
        this.properties = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type Plan
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [points]
    // Serialize the length for message field [points]
    bufferOffset = _serializer.uint32(obj.points.length, buffer, bufferOffset);
    obj.points.forEach((val) => {
      bufferOffset = PlanPoint.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [point_properties]
    // Serialize the length for message field [point_properties]
    bufferOffset = _serializer.uint32(obj.point_properties.length, buffer, bufferOffset);
    obj.point_properties.forEach((val) => {
      bufferOffset = PlanPointProperty.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [id]
    bufferOffset = _serializer.string(obj.id, buffer, bufferOffset);
    // Serialize message field [properties]
    // Serialize the length for message field [properties]
    bufferOffset = _serializer.uint32(obj.properties.length, buffer, bufferOffset);
    obj.properties.forEach((val) => {
      bufferOffset = marti_common_msgs.msg.KeyValue.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type Plan
    let len;
    let data = new Plan(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [points]
    // Deserialize array length for message field [points]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.points = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.points[i] = PlanPoint.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [point_properties]
    // Deserialize array length for message field [point_properties]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.point_properties = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.point_properties[i] = PlanPointProperty.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [id]
    data.id = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [properties]
    // Deserialize array length for message field [properties]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.properties = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.properties[i] = marti_common_msgs.msg.KeyValue.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    length += 56 * object.points.length;
    object.point_properties.forEach((val) => {
      length += PlanPointProperty.getMessageSize(val);
    });
    length += _getByteLength(object.id);
    object.properties.forEach((val) => {
      length += marti_common_msgs.msg.KeyValue.getMessageSize(val);
    });
    return length + 16;
  }

  static datatype() {
    // Returns string type for a message object
    return 'marti_nav_msgs/Plan';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'f87359e0c38bc2de4c9250c56b8b6d3f';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # This message represents a plan along a roadway
    std_msgs/Header                header
    
    # List of points in the plan
    PlanPoint[]                    points
    
    # Location for placing custom per point properties
    # Used for unusual things such as intersections or crosswalks
    PlanPointProperty[]            point_properties
    
    # Per route details
    string id
    marti_common_msgs/KeyValue[]   properties
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: marti_nav_msgs/PlanPoint
    # Position and heading for this point in the plan
    float64 x
    float64 y
    float64 z
    float64 yaw
    
    # Maximum speed in meters per second
    float32 speed
    
    # Road details for this point in the plan
    # Set to < 0 to mark as invalid
    int64 lane_id
    int64 segment_id
    
    int32 FLAG_REVERSE = 1
    int32 FLAG_STOP_POINT = 2
    
    # Bitmask of common per point boolean flags
    int32 flags
    
    ================================================================================
    MSG: marti_nav_msgs/PlanPointProperty
    # Index of the point in the plan these properties apply to
    uint64 index
    
    # The properties for this point in the plan
    marti_common_msgs/KeyValue[]   properties
    
    ================================================================================
    MSG: marti_common_msgs/KeyValue
    # An arbitrary key-value pair
    
    string key
    string value
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new Plan(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.points !== undefined) {
      resolved.points = new Array(msg.points.length);
      for (let i = 0; i < resolved.points.length; ++i) {
        resolved.points[i] = PlanPoint.Resolve(msg.points[i]);
      }
    }
    else {
      resolved.points = []
    }

    if (msg.point_properties !== undefined) {
      resolved.point_properties = new Array(msg.point_properties.length);
      for (let i = 0; i < resolved.point_properties.length; ++i) {
        resolved.point_properties[i] = PlanPointProperty.Resolve(msg.point_properties[i]);
      }
    }
    else {
      resolved.point_properties = []
    }

    if (msg.id !== undefined) {
      resolved.id = msg.id;
    }
    else {
      resolved.id = ''
    }

    if (msg.properties !== undefined) {
      resolved.properties = new Array(msg.properties.length);
      for (let i = 0; i < resolved.properties.length; ++i) {
        resolved.properties[i] = marti_common_msgs.msg.KeyValue.Resolve(msg.properties[i]);
      }
    }
    else {
      resolved.properties = []
    }

    return resolved;
    }
};

module.exports = Plan;
